#!/usr/bin/perl 

#Copyright (c) 2004 Istituto Nazionale di Fisica Nucleare
#For license conditions see http://www.cnaf.infn.it/license.html
#(c) by Guido Cuscela <g.cuscela@tin.it> and
#Giacinto Donvito <giacinto.donvito@ba.infn.it>, INFN-BARI

#use Data::Dumper;
use Getopt::Long;

my @queues = ();
my ($lrms,$help);
GetOptions( 
		"lrms:s" => \$lrms,
		"help" => \$help
	  );

if(defined($help)) {
	exit 0;
}
elsif (!$lrms) {
	exit 0;
}
else{
	unless($lrms =~ /\bpbs\b|\blsf\b/i){
		exit 0;
	}
}

my $bdii=`ps -eaf 2>/dev/null | grep ldap 2>/dev/null | grep bdii 2>/dev/null | head -n1 2>/dev/null`;
$bdii=~/slapd -f (\/\S+)\/\d+/;
$bdii=$1;
exit unless($bdii);
$bdii=~s/\/\//\//;
$bdii.="/tmp/CE.ldif";
open(IN_Q,$bdii);
@grid_q=<IN_Q>;
chop(@grid_q);
close(IN_Q);
unless($#grid_q ne "-1"){
	my $count=180;
	until($#grid_q ne "-1" or $count==0){
		open(IN_Q,$bdii);
		@grid_q=<IN_Q>;
		chop(@grid_q);
		close(IN_Q);
		$count--;
		sleep 1;
	}
}

my $k=0;
foreach $queue (@grid_q){
	if ($queue =~ /GlueCEName:\s+(.+)/){
		$queues[$k] = $1;
		$k++;
	}
}
$hostname=`hostname -f 2>/dev/null`;
chop($hostname);
$queues = join('|',@queues);
my $q_jobs=0;

########################################
####                                ####
####             PBS                ####
####				    ####
########################################

if ($lrms =~ /pbs/i){

	use threads;
	use threads::shared;
	my $t_var : shared =0;
	my @out_list : shared =();
	my $t_loop=40;
	my $globus_loc_buf=`grep GLOBUS_LOCATION= /etc/globus.conf 2> /dev/null`;
	my ($globus_loc)=($globus_loc_buf=~ /GLOBUS_LOCATION=(.+)/);
	my $command_buff_search=`grep QSTAT $globus_loc/libexec/globus-sh-tools-vars.sh 2> /dev/null | sed "s/GLOBUS_SH_QSTAT=//g" 2> /dev/null`;
	my ($command_search)=($command_buff_search=~ /"(.+)\/qstat"/);
	unless($command_search=~/\w+/){
		$command_search=`whereis diagnose 2>/dev/null`;
		if($command_search=~/diagnose:\s+(\S+)/){
			my $tmp_command=$1;
			my $ver=`file $1 2>/dev/null`;
			if($ver=~/executable/){
				$command=$tmp_command;
			}
			else{
				$command_search=`which diagnose 2>/dev/null`;
				if($command_search=~/^(\S+diagnose)/){
					$command=$1;
				}
				else{$command="diagnose";}
			}
		}
		else{
			$command_search=`which diagnose 2>/dev/null`;
			if($command_search=~/^(\S+diagnose)/){
				$command=$1;
			}
			else{$command="diagnose";}
		}
	}
	else{$command=$command_search."/diagnose";}
	$thread = threads->create(sub { @out_list=`$command -n -v 2>/dev/null`;$t_var=1; });
	until($t_loop==0){
                if($t_var==1){
                        $thread->join();
                        $t_loop=0;
                }
                else{
                        $t_loop--;
			sleep 1;
			exit 0 if($t_loop==0);
		}
	}
	chop(@out_list);
	$acc_path=`grep -e '^\\s*LRMS_SPOOL_DIR' /opt/gridice/monitoring/etc/JM.conf 2>/dev/null | grep -v -e '^\\s*#' 2>/dev/null | sed 's/^\\s*LRMS_SPOOL_DIR\\s*=\\s*\\(\\S*\\).*/\\1/' 2>/dev/null`;
	chop($acc_path);
	exit 0 unless($acc_path=~/\w+/);
	$total_jobs=`ls -1 $acc_path/../jobs/*.JB 2>/dev/null | wc -l 2>/dev/null`;
	($total_jobs)=($total_jobs=~/(\d+)/);

	foreach $line (@out_list){
		if(($line =~ /$queues/) and ($line =~ /(\S+)\s+(Idle|Drained|Running|Busy|Down|None)\s+(-*\d+):(\d+)/)){
			my @values=split(/\s+/,$line);
			$addr = $values[0];
			$status = $values[1];
			$free_cpu = $4 - $values[11];
			$free_cpu =0 if($free_cpu =~/^-/);
			$cpu = $4;
			$nodes_detail{$addr}{"Status"} = $status;
			$nodes_detail{$addr}{"Free_cpus"} = $free_cpu;
			$nodes_detail{$addr}{"Cpus"} = $cpu;
		}
		else {
			next;}
	}

	if($command_search=~/^(\S+)\/diagnose/){
		$command="$1/pbsnodes";
	}
	else{$command="pbsnodes";}
	my @pbs_nodes = `$command -a 2> /dev/null`;
	chop(@pbs_nodes);

	while(defined($node=shift(@pbs_nodes))){
		if($node =~ /^(\S+)/){
			$addr=$1;
			until($node=~/\s+status/){
				$node=shift(@pbs_nodes);
				last unless($node=~/\S+/);
			}
			if($node =~ /totmem=(\d+).+availmem=(\d+).+loadave=(\d*\.\d*),/){
				if(defined($nodes_detail{$addr}) and ($nodes_detail{$addr}{"Status"} ne "Down")){
					$totmem=$1;
					$avmem=$2;
					$loadave=$3;
					$nodes_detail{$addr}{"Load_av"} = $loadave;
					$nodes_detail{$addr}{"Occ_mem"} = ($totmem-$avmem)/1024;
					$nodes_detail{$addr}{"Tot_mem"} = $totmem/1024;
				}
			}
		}
	}
}

########################################
####                                ####
####             LSF                ####
####                                ####
########################################

else{
	$globus_loc_buf=`grep GLOBUS_LOCATION= /etc/globus.conf 2> /dev/null`;
	($globus_loc)=($globus_loc_buf=~ /GLOBUS_LOCATION=(.+)/);
	$command_buff_search=`grep BQUEUES $globus_loc/libexec/globus-sh-tools-vars.sh 2> /dev/null | sed "s/GLOBUS_SH_BQUEUES=//g" 2> /dev/null`;
	($command_search)=($command_buff_search=~ /"(.+)\/bqueues"/);
	my @out_list = `$command_search/bqueues -l 2> /dev/null`;
	chop(@out_list);

	my $list="";
	my $temp_list="";

	for ($i=0;$i<=$#out_list;$i++){
		if($out_list[$i] =~ /QUEUE:\s+($queues)$/){
			until($out_list[$i] =~ /HOSTS:/){$i++;}
			$hosts=$out_list[$i];
			@hosts= split(/HOSTS:\s+|\w+:.*|\s+/,$hosts); 
			shift(@hosts);
			$temp_list = "@hosts";
			if (@group=($temp_list =~ /\S+\//g)){
				@gr_lst = `$command_search/bmgroup 2> /dev/null`;
				chop(@gr_lst);
				shift(@gr_lst);
				foreach $grp (@group){
					chop($grp);
					foreach $gr (@gr_lst){
						if($gr =~ /^$grp/){
							my @gr = split(/\s+/,$gr);
							shift(@gr);
							$gl = "@gr";
							$temp_list =~ s/$grp\//$gl/;
						}
					}
				}
			}
			elsif($temp_list =~ /all hosts/){
				@hosts_list = `$command_search/bhosts -w 2> /dev/null`;
				chop(@hosts_list);
				for($j=1;$j<$#hosts_list;$j++){
					@sp = split(/\s+/,$hosts_list[$j]);
					$list_h[$j-1] = $sp[0];
				}
				$temp_list = join(' ',@list_h);
				$i=$#out_list+1;
			}
		}
		$list = $list." $temp_list";
	}
	@hosts=();
	%seen=();
	$z=0;
	@list_g = split(/\s+/,$list);
	shift(@list_g);
	foreach $item (@list_g) {
		$seen{$item}=$z++;
	}
	@hosts = keys(%seen);
	@hosts_list = `$command_search/bhosts -w 2> /dev/null`;
	chop(@hosts_list);
	foreach $line (@hosts_list){
		foreach $b (@hosts){
			if($line =~ /$b/ and !($line =~ /unlicensed/) and !defined($nodes_detail{$b})){
				my @list = split(/\s+/,$line);
				$nodes_detail{$b}{"Cpus"} = $list[3];
				$nodes_detail{$b}{"Free_cpus"} = $list[3]-$list[4];
				if(($list[4] gt 0) and ($list[1] eq "ok") and ($list[3] gt $list[4])){
					$nodes_detail{$b}{"Status"} = "Running";
				}
				elsif(($list[1] eq "unavail") or (($list[1] =~ /closed_Adm|closed_Excl|closed_LIM|closed_Lock|closed_Wind/) and ($list[3] eq $list[4]) and ($list[3] eq 0))){
					$nodes_detail{$b}{"Status"} = "Down";
				}
				elsif($list[1] eq "ok"){
					$nodes_detail{$b}{"Status"} = "Idle";
				}
				elsif(($list[1] =~ /closed_Busy|closed_Full/) and ($list[3] eq $list[4]) and ($list[3] gt 0)){
					$nodes_detail{$b}{"Status"} = "Busy";}
				else{$nodes_detail{$b}{"Status"} = "unknown";}
			}
		}
	}
	$hosts = join(' ',@hosts);
	@lsload = `$command_search/lsload -l $hosts 2> /dev/null`;
	@lshost = `$command_search/lshosts -w $hosts 2> /dev/null`;
	chop(@lsload);
	chop(@lshost);
	for($c=1;$c<=$#lsload;$c++){
		@lsl = split(/\s+/,$lsload[$c]);
		if(defined($nodes_detail{$lsl[0]}) and defined($lsl[2]) and !defined($nodes_detail{$lsl[0]}{"Load_av"})){
			$nodes_detail{$lsl[0]}{"Load_av"} = $lsl[3];
			chop($lsl[11]);
			chop($lsl[12]);
			$nodes_detail{$lsl[0]}{"Occ_mem"} = ($lsl[11]+$lsl[12]);
		}
	}
	for($c=1;$c<=$#lsload;$c++){
		@lsh = split(/\s+/,$lshost[$c]);
		if(defined($nodes_detail{$lsh[0]}) and ($lsh[4] ne "-") and !defined($nodes_detail{$lsh[0]}{"Tot_mem"})){
			chop($lsh[5]);
			chop($lsh[6]);
			$nodes_detail{$lsh[0]}{"Tot_mem"} = ($lsh[5]+$lsh[6]);
		}
	}
	my @bq_jobs=`$command_search/bqueues 2> /dev/null`;
	foreach $line (@bq_jobs){
		my @values=split(/\s+/,$line);
		if($values[8]=~/(\d+)/){
			$q_jobs += $1;
		}
	}
}
#print Dumper(%nodes_detail);
####################################
####				####
####	       OUTPUT		####
####				####
####################################

if(keys(%nodes_detail)){
	my $tot_free_cpu=0;
	my $tot_cpu=0;
	my $tot_nodes=0;
	my $tot_load=0;
	my $tot_mem=0;
	my $avail_mem=0;
	my $occ_mem=0;
	my @down=();
	my $down=0;
	my $char_count=0;
	my $complete=0;
	my $fake_jobs=0;

	foreach $chiave (sort keys(%nodes_detail)){
		$tot_nodes++;
		if(($nodes_detail{$chiave}{"Status"} eq "Idle") or ($nodes_detail{$chiave}{"Status"} eq "Busy") or ($nodes_detail{$chiave}{"Status"} eq "Running")){
			$tot_free_cpu += $nodes_detail{$chiave}{"Free_cpus"};
			$tot_cpu += $nodes_detail{$chiave}{"Cpus"};
			$tot_load += $nodes_detail{$chiave}{"Load_av"};
			$tot_mem += $nodes_detail{$chiave}{"Tot_mem"};
			$occ_mem += $nodes_detail{$chiave}{"Occ_mem"};
		}
		else{
			if ($lrms =~ /pbs/i){
				$fake_jobs += ($nodes_detail{$chiave}{"Cpus"} - $nodes_detail{$chiave}{"Free_cpus"});
			}
			$down++;
			if(($char_count+length($chiave))<1020){
				$char_count += length($chiave);
				push (@down,$chiave);
			}
			elsif($complete eq 0){
				$complete = 1;
				push (@down,"MORE");
			}
		}
		$downlist=join(',',@down);
	}
	$tot_load /= $tot_cpu;
	#$avail_mem = $tot_mem - $occ_mem;
	$tot_load=sprintf "%2.2f",$tot_load;
	$tot_load*=100;
	if ($lrms =~ /pbs/i){$q_jobs=$total_jobs-$tot_cpu+$tot_free_cpu-$fake_jobs;}
	if($down > 0){
		printf "%s\$%s\$%d\$%d\$%d\$%d\$%d\$%d\$%d\$%d\$%s\$",$lrms,$hostname,$tot_cpu,$tot_free_cpu,$q_jobs,$tot_load,$tot_mem,$occ_mem,$tot_nodes,$down,$downlist;
	}
	else{printf "%s\$%s\$%d\$%d\$%d\$%d\$%d\$%d\$%d\$%d\$-\$",$lrms,$hostname,$tot_cpu,$tot_free_cpu,$q_jobs,$tot_load,$tot_mem,$occ_mem,$tot_nodes,$down;}
}
