#!/usr/bin/perl -w

#$Id: PoolDir.pl,v 1.3 2005/01/10 12:07:04 tortone Exp $
# it counts total/free accounts on a CE ACCESS NODE per POOL
# author: Sergio Andreozzi
# rev. 1.0 16/10/2003

use strict;

my $LOGFILE="glue-poolAccountCounter.log";
open(STDERR, ">$LOGFILE" || die ("open STDERR failed"));

my $argPoolDir;
my $pointer = \@ARGV;
my $i = scalar(@$pointer);
if ($i eq 1)         {$argPoolDir = $ARGV[0];}
else                 {$argPoolDir = "/etc/grid-security/gridmapdir/";}

&collectPoolInfo;

sub collectPoolInfo {
   my %pool;

   opendir (POOLDIR, $argPoolDir) || die ("Unable to open pool directory");

   my @files = readdir(POOLDIR);

   foreach my $file (sort @files) {
         if ($file =~ /^([a-z,A-Z,_]+)(\d+)/) {

         #check if this pool account belong to a new pool
         my $found=0;
         while ((my $poolName,my $poolValue) = each( %pool ) ) {
                   if ($poolName eq $1)
                        {$found=1;}
            }

         # if so, initialize vars
         if ($found eq 0)
            { $pool{$1}{"total"}=1;
              $pool{$1}{"free"}=1;
            }
         else {
              $pool{$1}{"total"}++;
              my @fileInfo=stat($argPoolDir.$file);
              if ($fileInfo[3] eq 1)
                 {$pool{$1}{"free"}++;}
         }
     }
   }
   closedir(POOLDIR);

   while ((my $poolName,my $poolValue) = each( %pool ) ) {

print($poolName,"|",$poolName,"|",$pool{$poolName}{"total"},"|",,$pool{$poolName}{"free"},"*");
   }
}


