#!/usr/bin/perl

use Getopt::Long;
#use Data::Dumper;

my ($status,$id);
GetOptions( "s=s" => \$status,
            "id=s" => \$id,
	    "b" => \$backup,
	    "c" => \$check,
	    "d=s" => \$day,
	    "h" => \$h,
	    "help" => \$help
          );
my @values=("id","grid_id","user","group","qtime","queue","exit_status","start","end","status","used_cput","used_walltime","used_mem","used_vmem","exec_host","subject","name","r_proc");

exit print "\ntest_job.pl usage: perl $0 <option>\n\nOptions(one option allowed each time):\n\tno option: print infos about all jobs\n\ts=<status> :print infos about jobs in the given status\n\tid=<local_id> :print infos about job with the given local id\n\nExamples:\n\tperl test_job.pl\n\tperl test_job.pl -s=R\n\tperl test_job.pl -id=8051\n\n" if(defined($help) or defined($h));

sub retrieve{
        my $file=$_[0];
        open(RD,"<$file");
        my @temp_detail=<RD>;
        close(RD);
        my $j=0;
        my %detail=();
        foreach my $job_det (@temp_detail){
                my @fields=split(/\$/,$job_det);
                my $i=0;
                $detail{$fields[3]}{$fields[5]}{$fields[0]}{"line"}=$j;
                while($i<17){
                        $detail{$fields[3]}{$fields[5]}{$fields[0]}{$values[$i]}=$fields[$i];
                        $i++;
                }
                if($fields[$i]){
			$detail{$fields[3]}{$fields[5]}{$fields[0]}{"r_proc"}=$fields[$i];
			chop($detail{$fields[3]}{$fields[5]}{$fields[0]}{"r_proc"});
		}
		else{chop($detail{$fields[3]}{$fields[5]}{$fields[0]}{"name"});}
                $j++;
        }
        return \%detail;
}

sub store{
        my %hash=%{$_[0]};
        my $file=$_[1];
        open(JOB,">$file");
        foreach my $k (keys(%hash)){
                foreach my $k1 (keys(%{$hash{$k}})){
                        foreach my $k2 (sort keys(%{$hash{$k}{$k1}})){
                              my $out=$hash{$k}{$k1}{$k2}{"id"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"grid_id"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"user"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"group"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"qtime"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"queue"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"exit_status"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"start"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"end"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"status"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"used_cput"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"used_walltime"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"used_mem"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"used_vmem"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"exec_host"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"subject"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"name"};
                              $out=$out."\$".$hash{$k}{$k1}{$k2}{"r_proc"} if($hash{$k}{$k1}{$k2}{"r_proc"});
                              $out=$out."\n";
                              print JOB $out;
                       }
               }
        }
        close(JOB);
}

sub check {
	foreach $k (keys(%hash)){
		foreach $k1 (keys(%{$hash{$k}})){
			foreach $k2 (sort keys(%{$hash{$k}{$k1}})){
				if($hash{$k}{$k1}{$k2}{"status"} eq "Q"){
					if(!($hash{$k}{$k1}{$k2}{"id"}) or !($hash{$k}{$k1}{$k2}{"grid_id"}) or !($hash{$k}{$k1}{$k2}{"user"}) or !($hash{$k}{$k1}{$k2}{"group"}) or !($hash{$k}{$k1}{$k2}{"qtime"}>0) or !($hash{$k}{$k1}{$k2}{"queue"}) or !($hash{$k}{$k1}{$k2}{"subject"}) or !($hash{$k}{$k1}{$k2}{"name"})){
						$id=$hash{$k}{$k1}{$k2}{"id"};
						stampa(\%hash);
					}
					else{$id="";}
				}
				elsif($hash{$k}{$k1}{$k2}{"status"} eq "R"){
                                        if(!($hash{$k}{$k1}{$k2}{"id"}) or !($hash{$k}{$k1}{$k2}{"grid_id"}) or !($hash{$k}{$k1}{$k2}{"user"}) or !($hash{$k}{$k1}{$k2}{"group"}) or !($hash{$k}{$k1}{$k2}{"qtime"}>0) or !($hash{$k}{$k1}{$k2}{"queue"}) or !($hash{$k}{$k1}{$k2}{"subject"}) or !($hash{$k}{$k1}{$k2}{"name"}) or !($hash{$k}{$k1}{$k2}{"start"}>0) or !($hash{$k}{$k1}{$k2}{"used_cput"}>=0) or !($hash{$k}{$k1}{$k2}{"used_walltime"}>=0) or !($hash{$k}{$k1}{$k2}{"used_mem"}>=0) or !($hash{$k}{$k1}{$k2}{"used_vmem"}>=0) or !($hash{$k}{$k1}{$k2}{"exec_host"})){
                                                $id=$hash{$k}{$k1}{$k2}{"id"};
                                                stampa(\%hash);
                                        }
                                        else{$id="";}
                                }
				elsif($hash{$k}{$k1}{$k2}{"status"} eq "E"){
                                        if(!($hash{$k}{$k1}{$k2}{"id"}) or !($hash{$k}{$k1}{$k2}{"grid_id"}) or !($hash{$k}{$k1}{$k2}{"user"}) or !($hash{$k}{$k1}{$k2}{"group"}) or !($hash{$k}{$k1}{$k2}{"qtime"}>0) or !($hash{$k}{$k1}{$k2}{"queue"}) or !($hash{$k}{$k1}{$k2}{"subject"}) or !($hash{$k}{$k1}{$k2}{"name"}) or !($hash{$k}{$k1}{$k2}{"start"}>0) or !($hash{$k}{$k1}{$k2}{"used_cput"}>=0) or !($hash{$k}{$k1}{$k2}{"used_walltime"}>=0) or !($hash{$k}{$k1}{$k2}{"used_mem"}>=0) or !($hash{$k}{$k1}{$k2}{"used_vmem"}>=0) or !($hash{$k}{$k1}{$k2}{"exec_host"}) or !($hash{$k}{$k1}{$k2}{"end"}>0) or !($hash{$k}{$k1}{$k2}{"exit_status"}=~/\d+/)){
                                                $id=$hash{$k}{$k1}{$k2}{"id"};
                                                stampa(\%hash);
                                        }
                                        else{$id="";}
                                }
			}
		}
	}
}

sub stampa {
my %hash=%{$_[0]};
if(defined($status)){
	foreach $k (keys(%hash)){
	foreach $k1 (keys(%{$hash{$k}})){
        foreach $k2 (sort keys(%{$hash{$k}{$k1}})){
		if($hash{$k}{$k1}{$k2}{"status"} eq "$status"){
			printf "\nJID: %s\n",$hash{$k}{$k1}{$k2}{"id"};
			printf "GRID_ID: %s\n",$hash{$k}{$k1}{$k2}{"grid_id"};
			printf "USER: %s\n",$hash{$k}{$k1}{$k2}{"user"};
			printf "GROUP: %s\n",$hash{$k}{$k1}{$k2}{"group"};
			printf "QTIME: %s\n",$hash{$k}{$k1}{$k2}{"qtime"};
			printf "QUEUE: %s\n",$hash{$k}{$k1}{$k2}{"queue"};
			printf "EX_ST: %s\n",$hash{$k}{$k1}{$k2}{"exit_status"};
			printf "START: %s\n",$hash{$k}{$k1}{$k2}{"start"};
			printf "END: %s\n",$hash{$k}{$k1}{$k2}{"end"};
			printf "STATUS: %s\n",$hash{$k}{$k1}{$k2}{"status"};
			printf "CPUTIME: %s\n",$hash{$k}{$k1}{$k2}{"used_cput"};
			printf "WALLTIME: %s\n",$hash{$k}{$k1}{$k2}{"used_walltime"};
			printf "MEM: %s\n",$hash{$k}{$k1}{$k2}{"used_mem"};
			printf "VMEM: %s\n",$hash{$k}{$k1}{$k2}{"used_vmem"};
			printf "EXEC_HOST: %s\n",$hash{$k}{$k1}{$k2}{"exec_host"};
			printf "SUBJECT: %s\n",$hash{$k}{$k1}{$k2}{"subject"};
			printf "NAME: %s\n",$hash{$k}{$k1}{$k2}{"name"};
		}
	}}}
}
elsif(defined($id)){
	foreach $k (keys(%hash)){
	foreach $k1 (keys(%{$hash{$k}})){
        foreach $k2 (sort keys(%{$hash{$k}{$k1}})){
        	if($hash{$k}{$k1}{$k2}{"id"} eq "$id"){
                	printf "\nJID: %s\n",$hash{$k}{$k1}{$k2}{"id"};
	                printf "GRID_ID: %s\n",$hash{$k}{$k1}{$k2}{"grid_id"};
        	        printf "USER: %s\n",$hash{$k}{$k1}{$k2}{"user"};
                	printf "GROUP: %s\n",$hash{$k}{$k1}{$k2}{"group"};
	                printf "QTIME: %s\n",$hash{$k}{$k1}{$k2}{"qtime"};
        	        printf "QUEUE: %s\n",$hash{$k}{$k1}{$k2}{"queue"};
                	printf "EX_ST: %s\n",$hash{$k}{$k1}{$k2}{"exit_status"};
	                printf "START: %s\n",$hash{$k}{$k1}{$k2}{"start"};
        	        printf "END: %s\n",$hash{$k}{$k1}{$k2}{"end"};
                	printf "STATUS: %s\n",$hash{$k}{$k1}{$k2}{"status"};
	                printf "CPUTIME: %s\n",$hash{$k}{$k1}{$k2}{"used_cput"};
        	        printf "WALLTIME: %s\n",$hash{$k}{$k1}{$k2}{"used_walltime"};
                	printf "MEM: %s\n",$hash{$k}{$k1}{$k2}{"used_mem"};
	                printf "VMEM: %s\n",$hash{$k}{$k1}{$k2}{"used_vmem"};
        	        printf "EXEC_HOST: %s\n",$hash{$k}{$k1}{$k2}{"exec_host"};
                	printf "SUBJECT: %s\n",$hash{$k}{$k1}{$k2}{"subject"};
	                printf "NAME: %s\n",$hash{$k}{$k1}{$k2}{"name"};
        	}
	}}}
}
else{
	foreach $k (keys(%hash)){
	foreach $k1 (keys(%{$hash{$k}})){
	foreach $k2 (sort keys(%{$hash{$k}{$k1}})){
		print "\n{$k}{$k1}{$k2}\n";
	       	printf "JID: %s\n",$hash{$k}{$k1}{$k2}{"id"};
	        printf "GRID_ID: %s\n",$hash{$k}{$k1}{$k2}{"grid_id"};
        	printf "USER: %s\n",$hash{$k}{$k1}{$k2}{"user"};
                printf "GROUP: %s\n",$hash{$k}{$k1}{$k2}{"group"};
	        printf "QTIME: %s\n",$hash{$k}{$k1}{$k2}{"qtime"};
        	printf "QUEUE: %s\n",$hash{$k}{$k1}{$k2}{"queue"};
                printf "EX_ST: %s\n",$hash{$k}{$k1}{$k2}{"exit_status"};
	        printf "START: %s\n",$hash{$k}{$k1}{$k2}{"start"};
        	printf "END: %s\n",$hash{$k}{$k1}{$k2}{"end"};
                printf "STATUS: %s\n",$hash{$k}{$k1}{$k2}{"status"};
	        printf "CPUTIME: %s\n",$hash{$k}{$k1}{$k2}{"used_cput"};
        	printf "WALLTIME: %s\n",$hash{$k}{$k1}{$k2}{"used_walltime"};
               	printf "MEM: %s\n",$hash{$k}{$k1}{$k2}{"used_mem"};
                printf "VMEM: %s\n",$hash{$k}{$k1}{$k2}{"used_vmem"};
       	        printf "EXEC_HOST: %s\n",$hash{$k}{$k1}{$k2}{"exec_host"};
               	printf "SUBJECT: %s\n",$hash{$k}{$k1}{$k2}{"subject"};
                printf "NAME: %s\n",$hash{$k}{$k1}{$k2}{"name"};
	}}}
}
print "\n";}

$cwd="/var/spool/gridice";

unless($backup){
        %hash=%{retrieve("$cwd/JM/processed/.jmgridice_job_detail")};
	exit check() if($check);
        stampa(\%hash);
}
else{
        opendir(DIR,"$cwd/JM/processed/");
        @file_list=readdir(DIR);
        @file_list=grep !/^\.\.?$/,@file_list;
        @file_list=grep !/job_detail|grep_mess|acc_lines/,@file_list;
        unless($day){
                foreach $file (@file_list){
                        %hash=%{retrieve("$cwd/JM/processed/$file")};
                        stampa(\%hash);
                }
        }
        else{
                %hash=%{retrieve("$cwd/JM/processed/$day")};
                stampa(\%hash);
        }
}
